<?php
//###############################################
////////////////////// Easy Pages Light Modification  /////////////////
//////-----------------------                by Gio~Logist                --------------------\\\\\\\\\\
/////------------------------   http://www.giologist.com/vb    ---------------------\\\\\\\\\\
///////////////////////////////////////////////////////////////////////
//###############################################

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);
@set_time_limit(0);
 
// #################### PRE-CACHE TEMPLATES AND DATA ######################
 
// ###################### REQUIRE BACK-END (no comment)  ######################
// Why is this line everywhere? Take it out, and you'll see! No no no, i'm kidding. If you take this out and question
// me for support, or to ask why i'm adding all these useless lines... Well, just don't do it! Hah!
require_once('./global.php');

// Wonder what this does? Lets just put it here because it seems like the popular thing to do
require_once(DIR . '/includes/adminfunctions_template.php');
 
// So this right here gets the header for your admincp.. Yea, who would have ever guessed huh?
print_cp_header();

// If the user is not requesting anything, then make him! Shouldn't everyone just KNOW what they want? Easier said than done :p
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'main';
}

echo '<script>
function delete_layout(layoutid){
    if(confirm("Are you sure you want to delete this layout?")){
		location = "advanced_forums.php?do=delete_layout&layoutid=" + layoutid;
	}
}
</script>';

// #######################################################################
// ######### Load Your Pages - Because They Matter! (like the sales pitch? somehow everything "matters") #########
// #######################################################################
if ($_REQUEST['do'] == 'main')
{

	// Load the layouts. Grab the layouts. Be the layouts!!!
 	$get_those_layouts = $db->query_read("
		SELECT layout.*
		FROM " . TABLE_PREFIX . "advanced_forums_layout AS layout
		ORDER BY layout_title ASC
	");

	// Give the form a header. Because nothing in life is good without a little head..er
	print_form_header('advanced_forums');
	print_table_header("Tips & Suggestions");
	print_cells_row(array('<div class="smallfont">Once you add a layout type, be sure to create the corresponding templates that go with this layout. 
	<br /><br /><b>For example:</b> If you created a layout with a handler variable of "mylayout", a list of the corresponding templates would be as follows:
	<ul class="smallfont">
		<li>postbit_mylayout</li>
			<ul class="smallfont"><li>Customize the first post.</li></ul>
		<li>threadbit_mylayout</li>
			<ul class="smallfont"><li>Customize the way threads are listed in forumdisplay.</li></ul>
		<li><i>And so on, and so forth</i></li>
	</ul>
	<i><div><b>Note:</b> The templates you need to add (per layout) depends on what customizations you have enabled.</div>
	<div><b>Note:</b> If you have enabled customizations of a certain type, but haven\'t yet added a template, the product is configured to use vbulletin\'s default templates in the meantime.</div></i>
	<br /><b>Layouts we\'ve added ourselves for you:</b> Article, Graphic<div align="right">- Gio~Logist</div></div>
	<br /><a href="advanced_forums.php?do=add_layout">Add a Layout</a> 
	', ''));
	print_table_footer();
	
	print_form_header('advanced_forums');
	print_table_header("Advanced Forums Layouts");
	print_cells_row(array('Layout Info', '<div style="text-align: left;">Customizations</div>'), 1, 'tcat');

	// Set supported customizations
	$customs = "FORUMDISPLAY,postbit,threadbit,newthread";
	$customsarray = explode(',', $customs);
	
	// Here come the almighty layouts... The layouts that can one day make or break your success! Are your layouts cool? Are they cool enough? Are your layours lacking coolness? Does coolness even matter?
	while ($layout = $db->fetch_array($get_those_layouts))
	{
	
				// Reset a few variables here
				unset($layout_customs);
				unset($custom_enable);
				unset($custom_add);
				unset($custom_templates);
				
				//What customizations are made?
				$layout_customs_array = explode(',', $layout['customs']);
					foreach($customsarray AS $custom){
					
						// Construct enable/disable wording, and add/delete customization links
						$custom_enable[$custom] = "<span style='color: #66CC33; font-weight: bold;'>Enable</span>";
						$custom_add[$custom] = "add";
					
						if(in_array($custom, $layout_customs_array)){
						
							$layout_customs[$custom] = true;
							
							// ReConstruct enable/disable wording, and add/delete customization links
							$custom_enable[$custom] = "<span style='color: #666699;'>Disable</span>";
							$custom_add[$custom] = "delete";
							
							
							$custom_templates[$custom] .= '<a href="template.php?s=&do=add&&title=' . $custom . '_' . $layout[layout_var] . '">edit</a>';
						
						}
				
					}
					
				// No customizations made?
				if(!$custom_templates){
					$custom_templates = "No customizations";
				}
									
				// Lets build the layout area. Gotta make this nice and user friendly huh? Who likes coding anyways? Apparently i do. But i also like a good interface! Ya dig?
				$cell[1] .= "<strong><a href=\"advanced_forums.php?do=edit_layout&layoutid=$layout[layoutid]\"><b>$layout[layout_title]</b></a></strong>
				<div class=\"smallfont\"><a href=\"advanced_forums.php?do=edit_layout&layoutid=$layout[layoutid]\">Edit Layout</a>
				<a href=\"#\" onclick=\"delete_layout($layout[layoutid])\">Delete Layout</a>
				</div>
				";
				
				
				// Are you going to edit or delete? Hurry and make a decision, i'm running out of ideas here!
				$cell[2] .= "<table cellpadding=\"5\" cellspacing=\"1\" border=\"0\" class=\"smallfont\" width=\"100%\">
				<tr>
					<td width=\"50%\">
						<div style=\"float: right;\">$custom_templates[FORUMDISPLAY]</div>
						(<a href=\"advanced_forums.php?do=$custom_add[FORUMDISPLAY]_custom&layoutid=$layout[layoutid]&custom=FORUMDISPLAY\">$custom_enable[FORUMDISPLAY])</a> Forumdisplay Customization
					</td>
					<td width=\"50%\">
						<div style=\"float: right;\">$custom_templates[threadbit]</div>
						(<a href=\"advanced_forums.php?do=$custom_add[threadbit]_custom&layoutid=$layout[layoutid]&custom=threadbit\">$custom_enable[threadbit]</a>) Threadbit Customization
					</td>
				</tr>
				<tr>
					<td width=\"50%\">
						<div style=\"float: right;\">$custom_templates[postbit]</div>
						(<a href=\"advanced_forums.php?do=$custom_add[postbit]_custom&layoutid=$layout[layoutid]&custom=postbit\">$custom_enable[postbit])</a> First Postbit Customization
					</td>
					<td width=\"50%\">
						<div style=\"float: right;\">$custom_templates[newthread]</div>
						(<a href=\"advanced_forums.php?do=$custom_add[newthread]_custom&layoutid=$layout[layoutid]&custom=newthread\">$custom_enable[newthread])</a> New Thread Customization
					</td>
				</tr>
				</table>";
				print_cells_row($cell);
				unset($cell);
		
	}
	print_table_footer();
	print_cp_footer();	
}


// #######################################################################
// ######################## START ADD PAGE #############################
// #######################################################################
if ($_REQUEST['do'] == 'add_layout'){
	print_form_header('advanced_forums', 'add_update');
	print_table_header("Add A Layout");
	print_input_row("Layout Title", 'layout_title');
	print_input_row("Handler Variable<dfn>For corresponding templates such as postbit, the postbit template will be changed to postbit_variable for this layout.</dfn>", 'layout_var');
	print_submit_row("Submit!");  
	print_table_footer();
	print_cp_footer();	
} 

// #######################################################################
// ######################## START EDIT PAGE ############################
// #######################################################################
if ($_REQUEST['do'] == 'edit_layout')
{
	$layoutid = $_REQUEST['layoutid'];
	
 	$layout = $db->query_first("
		SELECT layout.*
		FROM " . TABLE_PREFIX . "advanced_forums_layout AS layout
		WHERE layoutid = $layoutid
	");
	
	print_form_header('advanced_forums', 'edit_update');
	print_table_header("Edit: $layout[layout_title]");
	echo "<input type=\"hidden\" name=\"layoutid\" value=\"$layoutid\">";
	print_input_row("Layout Title", 'layout_title', $layout[layout_title]);
	print_input_row("Handler Variable<dfn>For corresponding templates such as postbit, the postbit template will be changed to postbit_variable for this layout.</dfn>", 'layout_var', $layout[layout_var]);
	print_submit_row("Submit!");  
	print_table_footer();
	print_cp_footer();	
	
}

// #######################################################################
// ###################### START UPDATE EDITED ############################
// #######################################################################
if ($_REQUEST['do'] == 'edit_update'){

$layout_title = addslashes($_POST['layout_title']);
$layout_var = addslashes($_POST['layout_var']);

			$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "advanced_forums_layout
										SET	layout_title = '$layout_title',
											layout_var = '$layout_var'
											WHERE layoutid = " . $_POST[layoutid] . ";
   									");

	print_cp_redirect('advanced_forums.php');
}

// #######################################################################
// ###################### START UPDATE ADDED ############################
// #######################################################################
if ($_REQUEST['do'] == 'add_update'){

$layout_title = addslashes($_POST['layout_title']);
$layout_var = addslashes($_POST['layout_var']);

if(empty($layout_var) OR empty($layout_title)){

	echo "Please go back and fill in the missing fields";
	exit;

}
			$vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "advanced_forums_layout
										SET	layout_title = '$layout_title',
											layout_var = '$layout_var'
   									");


	print_cp_redirect('advanced_forums.php');
}

// #######################################################################
// ###################### START ADD CUSTOMIZATION ############################
// #######################################################################
if ($_REQUEST['do'] == 'add_custom'){

$layoutid = $_REQUEST['layoutid'];
$custom = $_REQUEST['custom'];

	// Get layout info
 	$layout = $db->query_first("
		SELECT layout.*
		FROM " . TABLE_PREFIX . "advanced_forums_layout AS layout
		WHERE layoutid = $layoutid
	");
	
// Invalid Layout?
if(!$layout){
	define('CP_REDIRECT', 'advanced_forums.php');
	print_stop_message('advanced_forums_layout_invalidlayout');
}

// Invalid customization type?
if($custom != 'FORUMDISPLAY' AND $custom != 'threadbit' AND $custom != 'postbit' AND $custom != 'newthread'){
	define('CP_REDIRECT', 'advanced_forums.php');
	print_stop_message('advanced_forums_layout_invalidcustomtype');
}

	// Do they have customizations listed already?
	if($layout['customs']){
	
		// If so, add a comma to the next one being addd
		$custom_prefix = "$layout[customs],";
		
		// Lets see if they're tryina add the same one
		$layout_customs = explode(',', $layout['customs']);
		
		// If they are, stop them
		if(in_array($custom, $layout_customs)){
			define('CP_REDIRECT', 'advanced_forums.php');
			print_stop_message('advanced_forums_layout_customalready', $custom);
		}
	
	}
	
	$new_customization = $custom_prefix . $custom;

			// Update Layout
			$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "advanced_forums_layout
										SET	customs = '" . $new_customization . "'
											WHERE layoutid = " . $layoutid . ";
   									");


	print_cp_redirect('advanced_forums.php');
}

// #######################################################################
// ###################### START DELETE CUSTOMIZATION ############################
// #######################################################################
if ($_REQUEST['do'] == 'delete_custom'){

$layoutid = $_REQUEST['layoutid'];
$custom = $_REQUEST['custom'];

	// Get layout info
 	$layout = $db->query_first("
		SELECT layout.*
		FROM " . TABLE_PREFIX . "advanced_forums_layout AS layout
		WHERE layoutid = $layoutid
	");
	
// Invalid Layout?
if(!$layout){
	define('CP_REDIRECT', 'advanced_forums.php');
	print_stop_message('advanced_forums_layout_invalidlayout');
}

// Invalid customization type?
if($custom != 'FORUMDISPLAY' AND $custom != 'threadbit' AND $custom != 'postbit' AND $custom != 'newthread'){
	define('CP_REDIRECT', 'advanced_forums.php');
	print_stop_message('advanced_forums_layout_invalidcustomtype');
}
	
	$new_customization = str_replace(",$custom", '', $layout[customs]);
	$new_customization = str_replace("$custom", '', $new_customization);
	
	echo $new_customization;

			// Update Layout
			$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "advanced_forums_layout
										SET	customs = '" . $new_customization . "'
											WHERE layoutid = " . $layoutid . ";
   									");


	print_cp_redirect('advanced_forums.php');
}

// #######################################################################
// ###################### START DELETE PAGE ############################
// #######################################################################
if ($_REQUEST['do'] == 'delete_layout'){

	$vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "advanced_forums_layout WHERE layoutid = '" . $_REQUEST['layoutid'] . "' LIMIT 1");

	print_cp_redirect('advanced_forums.php');
	
}

?> 